Index: apps/app_queue.c
===================================================================
--- apps/app_queue.c	(revision 242809)
+++ apps/app_queue.c	(working copy)
@@ -3868,11 +3868,27 @@
 	time_t callstart = qtds->starttime;
 	int callcompletedinsl = qtds->callcompletedinsl;
 	struct ast_datastore *datastore;
+	char vars[2048];
 
 	ast_queue_log(qe->parent->name, qe->chan->uniqueid, member->membername, "TRANSFER", "%s|%s|%ld|%ld|%d",
 				new_chan->exten, new_chan->context, (long) (callstart - qe->start),
 				(long) (time(NULL) - callstart), qe->opos);
 
+        if (qe->parent->eventwhencalled)
+		manager_event(EVENT_FLAG_AGENT, "AgentTransfer",
+						"Queue: %s\r\n"
+						"Uniqueid: %s\r\n"
+						"MemberName: %s\r\n"
+						"Extension: %s\r\n"
+						"Context: %s\r\n"
+						"HoldTime: %ld\r\n"
+						"TalkTime: %ld\r\n"
+						"Type: attended\r\n"
+						"%s",
+						qe->parent->name, qe->chan->uniqueid, member->membername, new_chan->exten, new_chan->context, 
+                                                (long)(callstart - qe->start), (long)(time(NULL) - callstart),
+						qe->parent->eventwhencalled == QUEUE_EVENT_VARIABLES ? vars2manager(qe->chan, vars, sizeof(vars)) : "");
+
 	update_queue(qe->parent, member, callcompletedinsl, (time(NULL) - callstart));
 	
 	/* No need to lock the channels because they are already locked in ast_do_masquerade */
@@ -4711,6 +4727,20 @@
 				ast_queue_log(queuename, qe->chan->uniqueid, member->membername, "TRANSFER", "%s|%s|%ld|%ld|%d",
 					qe->chan->exten, qe->chan->context, (long) (callstart - qe->start),
 					(long) (time(NULL) - callstart), qe->opos);
+                        	if (qe->parent->eventwhencalled)
+					manager_event(EVENT_FLAG_AGENT, "AgentTransfer",
+							"Queue: %s\r\n"
+							"Uniqueid: %s\r\n"
+							"MemberName: %s\r\n"
+							"Extension: %s\r\n"
+							"Context: %s\r\n"
+							"HoldTime: %ld\r\n"
+							"TalkTime: %ld\r\n"
+							"Type: blind\r\n"
+							"%s",
+							queuename, qe->chan->uniqueid, member->membername, qe->chan->exten, qe->chan->context, 
+	      	                                        (long)(callstart - qe->start), (long)(time(NULL) - callstart),
+							qe->parent->eventwhencalled == QUEUE_EVENT_VARIABLES ? vars2manager(qe->chan, vars, sizeof(vars)) : "");
 				send_agent_complete(qe, queuename, peer, member, callstart, vars, sizeof(vars), TRANSFER);
 			} else if (ast_check_hangup(qe->chan)) {
 				ast_queue_log(queuename, qe->chan->uniqueid, member->membername, "COMPLETECALLER", "%ld|%ld|%d",
